"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.listen = listen;
exports.dispatch = dispatch;

var listeners = [];

var ERROR = exports.ERROR = {
	LOADDATA: 0,
	COMMAND: 1,
	INSTANCE: 2,
	APICALL: 3,
	DESTROY: 4
};

function listen(fn) {
	listeners.push(fn);
	return function () {
		if (listeners.indexOf(fn) !== -1) {
			listeners.splice(listeners.indexOf(fn), 1);
		}
	};
}

function dispatch(errno, error, e) {
	for (var _len = arguments.length, payload = Array(_len > 3 ? _len - 3 : 0), _key = 3; _key < _len; _key++) {
		payload[_key - 3] = arguments[_key];
	}

	listeners.forEach(function (fn) {
		return fn.apply(undefined, [errno, error, e].concat(payload));
	});

	if (listeners.length === 0) {
		console.error(errno, error, e);
	}
}