"use strict";

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = querySelectorAll;


/**
 * @param {Element}
 * @param {string}
 * @return {Array}
 */
function querySelectorAll($dom, selector) {
	return [].concat(matchesSelector($dom, selector) ? $dom : [], Array.from($dom.querySelectorAll(selector)));
}

var matchesSelector = function () {
	var p = Element.prototype;
	var f = p.matches || p.webkitMatchesSelector || p.mozMatchesSelector || p.msMatchesSelector || function (selector) {
		return [].indexOf.call(document.querySelectorAll(selector), this) !== -1;
	};

	return function ($dom, selector) {
		return $dom instanceof Element ? f.call($dom, selector) : false;
	};
}();