'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = redboxWrapper;

var _errorhub = require('../errorhub');

var errorhub = _interopRequireWildcard(_errorhub);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var $redbox = document.createElement('div');

function redboxWrapper(errormsg, stash, tryFn) {
	if (process.env.NODE_ENV !== 'production') {
		if (stash.$redbox) {
			var ReactDOM = require('react-dom');
			ReactDOM.unmountComponentAtNode(stash.$redbox);
			$redbox.removeChild(stash.$redbox);
			delete stash.$redbox;

			if ($redbox.children.length === 0 && $redbox.parentNode) {
				$redbox.parentNode.removeChild($redbox);
			}
		}
	}

	try {
		return tryFn();
	} catch (e) {
		if (process.env.NODE_ENV !== 'production') {
			if (document.body && $redbox.children.length === 0) {
				document.body.parentElement.appendChild($redbox);
			}

			var React = require('react');
			var _ReactDOM = require('react-dom');
			var RedBox = require('redbox-react');
			stash.$redbox = document.createElement('div');

			try {
				_ReactDOM.render(React.createElement(RedBox.default || RedBox, { error: e }), stash.$redbox);
				$redbox.appendChild(stash.$redbox);
			} catch (e) {
				delete stash.$redbox;
			}
		}

		stash.failing = true;
		errorhub.dispatch(errorhub.ERROR.INSTANCE, errormsg, e, stash);
	}
}