'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.default = resolveDataAttribute;

var _scripts = require('../loader/scripts');

function _toArray(arr) { return Array.isArray(arr) ? arr : Array.from(arr); }

/**
 * @param {Element}
 * @param {function}
 */
function resolveDataAttribute($element, attrName, fn) {
	($element.getAttribute(attrName) || '').split('$').filter(function (attrValue) {
		return attrValue;
	}).map(function (attrValue) {
		var _attrValue$split = attrValue.split(':');

		var _attrValue$split2 = _toArray(_attrValue$split);

		var attrPlugin = _attrValue$split2[0];

		var pvar = _attrValue$split2.slice(1);

		var matched = attrPlugin.match(/^(?:([^\[]*)(?:\[([^\]]*)\])?@)?(([^\[]*)(?:\[([^\]]*)\])?)$/);
		var target = matched[1] || '';
		var targetId = matched[2] || '';
		var name = matched[3] + (matched[5] === undefined ? "[]" : "");
		var pluginName = matched[4];
		var pluginId = matched[5] || '';
		var createData = function createData() {
			return (0, _scripts.loadData)(pvar.join(':') || null);
		};
		var data = createData();

		fn({ pluginName: pluginName, pluginId: pluginId, target: target, targetId: targetId, name: name, data: data, createData: createData });
	});
}