'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.bindAttribute = exports.bindSelector = exports.bind = exports.bindGlobal = exports.bindSystem = exports.bindApi = exports.mockApi = exports.resolveDataAttribute = exports.querySelectorAll = exports.contains = exports.unloadSystem = exports.loadSystem = exports.updateGlobal = exports.unloadGlobal = exports.loadGlobal = exports.commandAll = exports.command = exports.findPlugins = exports.unloadPlugins = exports.load = exports.unloadScripts = exports.loadScripts = undefined;

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _scripts = require('./loader/scripts');

Object.defineProperty(exports, 'loadScripts', {
	enumerable: true,
	get: function get() {
		return _scripts.loadScripts;
	}
});
Object.defineProperty(exports, 'unloadScripts', {
	enumerable: true,
	get: function get() {
		return _scripts.unloadScripts;
	}
});

var _selector = require('./loader/selector');

Object.defineProperty(exports, 'load', {
	enumerable: true,
	get: function get() {
		return _selector.load;
	}
});
Object.defineProperty(exports, 'unloadPlugins', {
	enumerable: true,
	get: function get() {
		return _selector.unloadPlugins;
	}
});
Object.defineProperty(exports, 'findPlugins', {
	enumerable: true,
	get: function get() {
		return _selector.findPlugins;
	}
});
Object.defineProperty(exports, 'command', {
	enumerable: true,
	get: function get() {
		return _selector.command;
	}
});
Object.defineProperty(exports, 'commandAll', {
	enumerable: true,
	get: function get() {
		return _selector.commandAll;
	}
});

var _global = require('./loader/global');

Object.defineProperty(exports, 'loadGlobal', {
	enumerable: true,
	get: function get() {
		return _global.loadGlobal;
	}
});
Object.defineProperty(exports, 'unloadGlobal', {
	enumerable: true,
	get: function get() {
		return _global.unloadGlobal;
	}
});
Object.defineProperty(exports, 'updateGlobal', {
	enumerable: true,
	get: function get() {
		return _global.updateGlobal;
	}
});

var _system = require('./loader/system');

Object.defineProperty(exports, 'loadSystem', {
	enumerable: true,
	get: function get() {
		return _system.loadSystem;
	}
});
Object.defineProperty(exports, 'unloadSystem', {
	enumerable: true,
	get: function get() {
		return _system.unloadSystem;
	}
});
exports.loader = loader;
exports.loaderGlobal = loaderGlobal;
exports.updatePlugins = updatePlugins;
exports.updatePlugin = updatePlugin;
exports.unload = unload;
exports.update = update;

var _contains2 = require('./lib/contains');

var _contains3 = _interopRequireDefault(_contains2);

var _querySelectorAll2 = require('./lib/querySelectorAll');

var _querySelectorAll3 = _interopRequireDefault(_querySelectorAll2);

var _resolveDataAttribute2 = require('./lib/resolveDataAttribute');

var _resolveDataAttribute3 = _interopRequireDefault(_resolveDataAttribute2);

var _api = require('./loader/api');

var _api2 = require('./lib/api');

var _api3 = _interopRequireDefault(_api2);

var _createInstance2 = require('./lib/createInstance');

var _createInstance3 = _interopRequireDefault(_createInstance2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.contains = _contains3.default;
exports.querySelectorAll = _querySelectorAll3.default;
exports.resolveDataAttribute = _resolveDataAttribute3.default;


var _PluginApi = (0, _api3.default)();
var _createInstance = (0, _createInstance3.default)(_PluginApi);

var mockApi = exports.mockApi = (0, _api.mockApi)(_PluginApi);
var bindApi = exports.bindApi = (0, _api.bindApi)(_PluginApi);
var bindSystem = exports.bindSystem = (0, _system.bindSystem)(_createInstance);
var bindGlobal = exports.bindGlobal = (0, _global.bindGlobal)(_createInstance);

var _bind2 = (0, _selector.bind)(_createInstance);

var bind = _bind2.bind;
var bindSelector = _bind2.bindSelector;
var bindAttribute = _bind2.bindAttribute;
exports.bind = bind;
exports.bindSelector = bindSelector;
exports.bindAttribute = bindAttribute;
function loader(fn) {
	var __PluginApi = (0, _api3.default)(_PluginApi);
	var __createInstance = (0, _createInstance3.default)(__PluginApi);
	var mockApi = (0, _api.mockApi)(__PluginApi);
	var bindApi = (0, _api.bindApi)(__PluginApi);
	var bindSystem = (0, _system.bindSystem)(__createInstance);
	var bindGlobal = (0, _global.bindGlobal)(__createInstance);

	var _bind3 = (0, _selector.bind)(__createInstance);

	var bind = _bind3.bind;
	var bindSelector = _bind3.bindSelector;
	var bindAttribute = _bind3.bindAttribute;


	fn({ mockApi: mockApi, bindApi: bindApi, bindSystem: bindSystem, bindGlobal: bindGlobal, bind: bind, bindSelector: bindSelector, bindAttribute: bindAttribute });
}

function loaderGlobal(fn) {
	fn({ mockApi: mockApi, bindApi: bindApi, bindSystem: bindSystem, bindGlobal: bindGlobal, bind: bind, bindSelector: bindSelector, bindAttribute: bindAttribute });
}

/**
 * @param {object}
 * @param {object}
 */
function updatePlugins(plugins, data) {
	Object.keys(data || {}).forEach(function (key) {
		var _ref = key.match(/^(.*?)(?:::(.+))?$/) || [];

		var _ref2 = _slicedToArray(_ref, 3);

		var name = _ref2[1];
		var _ref2$ = _ref2[2];
		var method = _ref2$ === undefined ? 'update' : _ref2$;


		(0, _global.updateGlobal)(name, data[key]);

		plugins.filter(function (val) {
			return val.pluginName === name || val.name === name;
		}).filter(function (_ref3) {
			var instance = _ref3.instance;
			return instance && instance[method];
		}).forEach(function (_ref4) {
			var instance = _ref4.instance;
			return instance[method](data[key]);
		});
	});
}

/**
 * @param {object}
 * @param {object}
 */
function updatePlugin(plugin, data) {
	Object.keys(data || {}).forEach(function (key) {
		var _ref5 = key.match(/^(.*?)(?:::(.+))?$/) || [];

		var _ref6 = _slicedToArray(_ref5, 3);

		var name = _ref6[1];
		var _ref6$ = _ref6[2];
		var method = _ref6$ === undefined ? 'update' : _ref6$;


		if (plugin && plugin.instance && plugin.instance[method] && !name) {
			plugin.instance[method](data[key]);
		}
	});
}

/**
 * @param {Element}
 */
function unload($dom) {
	(0, _selector.unloadPlugins)((0, _selector.findPlugins)($dom));
}

/**
 * @param {Element}
 * @param {object}
 */
function update($dom, data) {
	updatePlugins((0, _selector.findPlugins)($dom), data);
}