'use strict';

Object.defineProperty(exports, "__esModule", {
	value: true
});
exports.loadScripts = loadScripts;
exports.unloadScripts = unloadScripts;
exports.loadData = loadData;

var _errorhub = require('../errorhub');

var errorhub = _interopRequireWildcard(_errorhub);

var _querySelectorAll = require('../lib/querySelectorAll');

var _querySelectorAll2 = _interopRequireDefault(_querySelectorAll);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

var $scripts = {};

/**
 * @param {Element}
 */
function loadScripts($dom) {
	(0, _querySelectorAll2.default)($dom, 'script[type^="data-plugin/"]').forEach(function ($script) {
		var pvar = ($script.getAttribute('type') || '').replace(/data-plugin\//, '');
		$scripts[pvar] = $script;
	});
}

/**
 * @param {Element}
 */
function unloadScripts($dom) {
	(0, _querySelectorAll2.default)($dom, 'script[type^="data-plugin/"]').forEach(function ($script) {
		var pvar = ($script.getAttribute('type') || '').replace(/data-plugin\//, '');
		delete $scripts[pvar];
	});
}

/**
 * @param {string}
 * @return {mixed}
 */
function loadData(pvar) {
	try {
		if ($scripts[pvar]) {
			return JSON.parse($scripts[pvar].textContent);
		}
	} catch (e) {
		errorhub.dispatch(errorhub.ERROR.LOADDATA, 'Failed loaddata', e, pvar);
	}

	try {
		if (pvar) {
			return JSON.parse(pvar);
		}
	} catch (e) {}

	return pvar;
}